From 50b950bb7b2c074bbfaf6c5bff3473bb90aecb08 Mon Sep 17 00:00:00 2001
From: Maxim Treskin <zerthurd@gmail.com>
Date: Mon, 27 Sep 2010 01:52:27 +0700
Subject: [PATCH] Do not use deprecated public_key:pem_to_der/2 with unexpected return value

---
 lib/ssh/src/ssh_file.erl |    9 +++++++--
 1 files changed, 7 insertions(+), 2 deletions(-)

diff --git a/lib/ssh/src/ssh_file.erl b/lib/ssh/src/ssh_file.erl
index 963f0cf..01b6b6d 100755
--- a/lib/ssh/src/ssh_file.erl
+++ b/lib/ssh/src/ssh_file.erl
@@ -205,11 +205,16 @@ read_public_key_v1(File) ->
 %% pem_type("ssh-rsa") -> "RSA".
 
 read_private_key_v2(File, Type) ->
-     case catch (public_key:pem_to_der(File)) of
-	 {ok, [{_, Bin, not_encrypted}]} ->
+     try
+         {ok, Content} = file:read_file(File),
+         public_key:pem_decode(Content)
+     of
+         [{_, Bin, not_encrypted}] ->
 	     decode_private_key_v2(Bin, Type);
 	 Error -> %% Note we do not handle password encrypted keys at the moment
 	     {error, Error}
+     catch
+         _:Error -> {error, Error}
      end.
 %%  case file:read_file(File) of
 %% 	{ok,Bin} ->
-- 
1.7.2.2

